
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Corrective_actionsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const corrective_actions = await db.corrective_actions.create(
            {
                id: data.id || undefined,
        
        capa_number: data.capa_number
        ||
        null
            ,
            
        type: data.type
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        priority: data.priority
        ||
        null
            ,
            
        opened_at: data.opened_at
        ||
        null
            ,
            
        due_at: data.due_at
        ||
        null
            ,
            
        closed_at: data.closed_at
        ||
        null
            ,
            
        root_cause: data.root_cause
        ||
        null
            ,
            
        action_plan: data.action_plan
        ||
        null
            ,
            
        effectiveness_check: data.effectiveness_check
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await corrective_actions.setNonconformance( data.nonconformance || null, {
            transaction,
        });
        
        await corrective_actions.setOwner( data.owner || null, {
            transaction,
        });
        
        await corrective_actions.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.corrective_actions.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: corrective_actions.id,
            },
            data.attachments,
            options,
        );
        

        return corrective_actions;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const corrective_actionsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                capa_number: item.capa_number
            ||
            null
            ,
            
                type: item.type
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                priority: item.priority
            ||
            null
            ,
            
                opened_at: item.opened_at
            ||
            null
            ,
            
                due_at: item.due_at
            ||
            null
            ,
            
                closed_at: item.closed_at
            ||
            null
            ,
            
                root_cause: item.root_cause
            ||
            null
            ,
            
                action_plan: item.action_plan
            ||
            null
            ,
            
                effectiveness_check: item.effectiveness_check
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const corrective_actions = await db.corrective_actions.bulkCreate(corrective_actionsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < corrective_actions.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.corrective_actions.getTableName(),
                    belongsToColumn: 'attachments',
                    belongsToId: corrective_actions[i].id,
                },
                data[i].attachments,
                options,
            );
        }
        

        return corrective_actions;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const corrective_actions = await db.corrective_actions.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.capa_number !== undefined) updatePayload.capa_number = data.capa_number;
        
        
        if (data.type !== undefined) updatePayload.type = data.type;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.priority !== undefined) updatePayload.priority = data.priority;
        
        
        if (data.opened_at !== undefined) updatePayload.opened_at = data.opened_at;
        
        
        if (data.due_at !== undefined) updatePayload.due_at = data.due_at;
        
        
        if (data.closed_at !== undefined) updatePayload.closed_at = data.closed_at;
        
        
        if (data.root_cause !== undefined) updatePayload.root_cause = data.root_cause;
        
        
        if (data.action_plan !== undefined) updatePayload.action_plan = data.action_plan;
        
        
        if (data.effectiveness_check !== undefined) updatePayload.effectiveness_check = data.effectiveness_check;
        
        
        updatePayload.updatedById = currentUser.id;

        await corrective_actions.update(updatePayload, {transaction});

        
        
        if (data.nonconformance !== undefined) {
            await corrective_actions.setNonconformance(
              
              data.nonconformance,
              
              { transaction }
            );
        }
        
        if (data.owner !== undefined) {
            await corrective_actions.setOwner(
              
              data.owner,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await corrective_actions.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.corrective_actions.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: corrective_actions.id,
            },
            data.attachments,
            options,
        );
        

        return corrective_actions;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const corrective_actions = await db.corrective_actions.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of corrective_actions) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of corrective_actions) {
                await record.destroy({transaction});
            }
        });


        return corrective_actions;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const corrective_actions = await db.corrective_actions.findByPk(id, options);

        await corrective_actions.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await corrective_actions.destroy({
            transaction
        });

        return corrective_actions;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const corrective_actions = await db.corrective_actions.findOne(
            { where },
            { transaction },
        );

        if (!corrective_actions) {
            return corrective_actions;
        }

        const output = corrective_actions.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.nonconformance = await corrective_actions.getNonconformance({
            transaction
        });
        
        
        output.owner = await corrective_actions.getOwner({
            transaction
        });
        
        
        output.attachments = await corrective_actions.getAttachments({
            transaction
        });
        
        
        output.organizations = await corrective_actions.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.nonconformances,
        as: 'nonconformance',
        
        where: filter.nonconformance ? {
          [Op.or]: [
            { id: { [Op.in]: filter.nonconformance.split('|').map(term => Utils.uuid(term)) } },
            {
              ncr_number: {
                [Op.or]: filter.nonconformance.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'owner',
        
        where: filter.owner ? {
          [Op.or]: [
            { id: { [Op.in]: filter.owner.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.owner.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



      {
        model: db.file,
        as: 'attachments',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.capa_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'corrective_actions',
                        'capa_number',
                        filter.capa_number,
                    ),
                };
            }
            
            if (filter.root_cause) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'corrective_actions',
                        'root_cause',
                        filter.root_cause,
                    ),
                };
            }
            
            if (filter.action_plan) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'corrective_actions',
                        'action_plan',
                        filter.action_plan,
                    ),
                };
            }
            
            if (filter.effectiveness_check) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'corrective_actions',
                        'effectiveness_check',
                        filter.effectiveness_check,
                    ),
                };
            }
            

            
            

            
            if (filter.opened_atRange) {
                const [start, end] = filter.opened_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    opened_at: {
                    ...where.opened_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    opened_at: {
                    ...where.opened_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.due_atRange) {
                const [start, end] = filter.due_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    due_at: {
                    ...where.due_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    due_at: {
                    ...where.due_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.closed_atRange) {
                const [start, end] = filter.closed_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    closed_at: {
                    ...where.closed_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    closed_at: {
                    ...where.closed_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.type) {
                where = {
                    ...where,
                type: filter.type,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            
            if (filter.priority) {
                where = {
                    ...where,
                priority: filter.priority,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.corrective_actions.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'corrective_actions',
                        'capa_number',
                        query,
                    ),
                ],
            };
        }

        const records = await db.corrective_actions.findAll({
            attributes: [ 'id', 'capa_number' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['capa_number', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.capa_number,
        }));
    }

    
};

